=begin
Copyright 2011 (c) TIG
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###

TextureRotate.rb >> ../Plugins/ folder

and image files >>> ../Plugins/TIGtools/ folder

TextureAdjust.png
TextureNudge.png
TextureRotate.png
TextureScale.png
TextureShunt.png
TextureTweak.png

###
Usage:

TextureRotate:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureRotate' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default rotation of 90.0 degrees. 
Enter any +/-ve angle and the texture on the selected face rotates about 
the first vertex of that face by that given angle.
The last entered angle is remembered during that session.
To run the Tool without a dialog you can use 'TextureTools::Rotate.new(45)' - 
where the angle is passed directly to the texture, in this case it is 
45 degrees; this allows the texture-rotation to be run from within another 
tool which passes an angle directly to it without an interrupting dialog.

TextureAdjust:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureAdjust' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default adjust angle of 1.0.
Enter the adjust angle value required - e.g. 15.0
The last entered adjust angle is remembered during that session.
Now use the arrow-keys to adjust the texture by the current angle - 
the U/X +/- is right/left arrows.
A +ve arrow [right] applies the angle CCW.
A -ve arrow [left] applies the angle CW [i.e. as if it's -ve].
Thus entering 0.5 and pressing the right-arrow repeatedly will rotate the 
texture by increments of 0.5 degrees: useful for fine adjustments.
Thus you can reverse the rotation by using the other arrow...
The texture on the selected face roattes the given angle, or 10x if the 
Shift key is being held down.
The rotation is anchored on the face's first vertex.
To open the dialog to reset the Tool's Adjust Angle value press <Esc>.
Choose another Tool to end TextureAdjust.

TextureShunt:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureShunt' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default shunt factors of U=1 & V=1
in 'units' - i.e. whatever the SKP's units are, e.g. 1cm
Enter any shunt values required [with or without units suffix] and the 
texture on the selected face shunts across the face by the given factors in 
the UV directions.
The last entered shunt factors are remembered during that session.
To run the Tool without a dialog you can use 
'TextureTools::Shunt.new('20mm','0')' - where the factors are passed 
directly as strings to the texture, in this case it is moved 20mm across 
in the U; this allows the texture-shunting to be run from within another 
tool which passes factors directly to it without an interrupting dialog.

TextureNudge:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureNudge' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default nudge factor of 1 unit - 
i.e. whatever the SKP's units are, e.g. 1mm
Enter the nudge value required [with or without units suffix].
The last entered nudge factor is remembered during that session.
Now use the arrow-keys to nudge the texture by the current distance - 
the U/X is right or left, and V/Y is up or down.
It is useful for fine adjustments to the texture's position.
The texture on the selected face nudges across by the given distance, or 10x
the distance if the Shift key is being held down.
To open the dialog to reset the Tool's Nudge value press <Esc>.
Choose another Tool to end TextureNudge.

TextureScale:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureScale' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default scale factors of U=0.5 & V=0.5.
Enter any scale values required [e.g. 0.5 & 1] and the texture on the 
selected face scales by the given factors in the UV directions; it is 
anchored on the face's first vertex.
The last entered scale factors are remembered during that session.
To run the Tool without a dialog you can use 
'TextureTools::Scale.new('2','1')' - where the factors are passed 
directly as strings to the texture, in this case it is scaled 2x in the U/X 
direction; this allows the texture-shunting to be run from within another 
tool which passes factors directly to it without an interrupting dialog.

TextureTweak:

Select ONE face that has a front material with a texture.
Note that a selection containing more that one thing is ignored.
Activate the Tool:-
...Either pick 'TextureTweak' off the Plugins submenu 'TextureTools...'
...Or View > Toolbars activate TextureTools-toolbar and click its button.
[Note: the toolbar is only available if the .png files exists]
A dialog appears showing the initial default tweak scale factor of 0.1.
Enter the tweak value required - e.g. 0.2
The last entered tweak scale factor is remembered during that session.
Now use the arrow-keys to tweak the texture by the current factor - 
the U/X +/- is right or left, and V/Y +/- is up or down.
A +ve arrow [right/up] applies the factor - e.g. 0.5
A -ve arrow [left/down] applies the inverse of the factor - e.g. 1/0.5=2
It is useful for fine adjustments to the texture's size.
Thus you can reverse scaling in an axis by using the inverse arrow...
The texture on the selected face scales the given factor, or 10x if the 
Shift key is being held down.
The scaling is anchored on the face's first vertex.
To open the dialog to reset the Tool's Tweak Scale value press <Esc>.
Choose another Tool to end TextureTweak.

###
Donations:
info @ revitrev.org via PayPal.com
###
Versions:
1.0 20110519 First Release - TextureRotate.
1.1 20110519 TextureTools expanded to include TextureShunt.
             Traps added for colinear vertices and > quad faces etc.
1.2 20110519 Minor toolbar coding glitch fixed.
1.3 20110519 TextureNudge with Arrow-Keys added.
1.4 20110520 New tools added, TextureScale & TextureTweak [Scale by Arrows] 
             & TextureAdjust [Rotate by Arrows]. Button png files adjusted.
             Use of a ',' instead of a '.' as a decimal-point now works.
1.5 20110520 Users may now type a '.' OR a ',' as a decimal-separator, 
             depending their preference, for any of the tools' dialogs - 
             issues with conversion of strings to lengths from potential 
             locale-wrong input is addressed in the code behind the scenes.
###
=end
#--------------------------------------------------------------------------
require 'sketchup.rb'
#--------------------------------------------------------------------------

module TextureTools

class Rotate

@@angle=nil

def initialize(angle=nil)
  @@angle='90.0' if not @@angle
  model=Sketchup.active_model
  ss=model.selection
  face=ss[0]
  return nil if not ss[0] or ss[1] or face.class!=Sketchup::Face
  return nil if not mat=face.material or not mat.texture
  if not angle
    return nil if not anglet=self.dialog()
    angle=anglet.tr(',', '.').to_f
    if angle==0
      UI.messagebox("¡El ángulo no puede ser CERO!")
      return nil if not anglet=self.dialog()
      angle=anglet.tr(',', '.').to_f
      return nil if angle==0
    end#if
    @@angle=anglet
    self.process(face, angle)
  else
    self.process(face, angle)
  end#if
end

def dialog()
  results=UI.inputbox(["Ángulo [grados]:           "], [@@angle], "Rotar Textura")
  return nil if not results
  return results[0]
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, angle=0.0)
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not mat.texture
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  tr=Geom::Transformation.rotation(pts[0], face.normal, angle.degrees)
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

end#class

#==========================================================================

class Adjust
  
  @@adjust=nil

if RUBY_PLATFORM=="i386-mswin32" ### PC
  KALXMINUS = 37          # Arrow Left Key 
  KARXPLUS  = 39          # Arrow Right Key 
  KSHIFT    = 16          # Shift Key 
else### MAC
  KALXMINUS = 63234       # Arrow Left Key 
  KARXPLUS  = 63235       # Arrow Right Key 
  KSHIFT    = 131072      # Shift Key 
end#if

def initialize()
  @@adjust='1.0' if not @@adjust
  model=Sketchup.active_model
  ss=model.selection
  @face=ss[0]
  return nil if not ss[0] or ss[1] or @face.class!=Sketchup::Face
  return nil if not @mat=@face.material or not @mat.texture
  @msg='Ajustar Textura: Ángulo CCW=Flecha-Derecha, CW=Flecha-Izquierda, +Mayúsculas=10x'
end

def activate
  Sketchup::set_status_text('Ajustar Textura: Introduce ángulo de Ajuste')
  @dialoged=false
  return nil if not aat=self.dialog()
  aa=aat.tr(',', '.').to_f
  if aa==0
    UI.messagebox("¡El ángulo no puede ser CERO!")
    return nil if not aat=self.dialog()
    aa=aat.tr(',', '.').to_f
    return nil if aa==0
  end#if
  @@adjust=aat
  @d=aa
  @shift=false
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==KSHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==KSHIFT
      @shift=true  
    else
     case key 
      when KALXMINUS
        if @shift
          self.process(-@d*10)
        else
          self.process(-@d)
        end
        self.reset()
      when KARXPLUS
        if @shift
          self.process(@d*10)
        else
          self.process(@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(angle=nil)
  face=@face
  mat=@mat
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not tex=mat.texture
  return nil if not angle or angle==0
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  tr=Geom::Transformation.rotation(pts[0], face.normal, angle.degrees)
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  results=UI.inputbox(["Ángulo [grados]:            "], [@@adjust], "Ajustar Textura")
  return nil if not results
  return results[0]
end

end#class
#==========================================================================

class Shunt

@@u=nil
@@v=nil

def initialize(u=nil,v=nil)### u and v are strings
  @@u='1' if not @@u
  @@v='1' if not @@v
  model=Sketchup.active_model
  ss=model.selection
  face=ss[0]
  return nil if not ss[0] or ss[1] or face.class!=Sketchup::Face
  return nil if not mat=face.material or not mat.texture
  if not u or not v
    uv=self.dialog()
    return nil if not uv
    ut=uv[0]
    return nil if not ut or ut==""
    vt=uv[1]
    return nil if not vt or vt==""
    u=ut.tr(',', '.')
    v=vt.tr(',', '.')
    @@u=ut
    @@v=vt
    self.process(face, u, v)
  else
    u=u.to_s.tr(',', '.')
    v=v.to_s.tr(',', '.')
    self.process(face, u, v)
  end#if
end

def dialog()
  u=@@u
  v=@@v
  results=UI.inputbox(["U: ", "V: "], [u, v], "Desviar Textura")
  return nil if not results
  return results
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, u=nil, v=nil)
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not tex=mat.texture
  return nil if not u or not v
  begin
    u=u.to_l
  rescue
    u=u.tr('.', ',').to_l
    rescue
      return nil
  end
  begin
    v=v.to_l
  rescue
    v=v.tr('.', ',').to_l
    rescue
      return nil
  end
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  tx=Geom::Transformation.translation(vx)
  ty=Geom::Transformation.translation(vy)
  tr=tx * ty
  ###
  tpts=[]
  (0..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

end#class

#==========================================================================

class Nudge

@@nudge=nil

if RUBY_PLATFORM=="i386-mswin32" ### PC
  KALXMINUS = 37          # Arrow Left Key 
  KARXPLUS  = 39          # Arrow Right Key 
  KAUYPLUS  = 38          # Arrow Up Key 
  KADYMINUS = 40          # Arrow Down Key 
  KSHIFT    = 16          # Shift Key 
else### MAC
  KALXMINUS = 63234       # Arrow Left Key 
  KARXPLUS  = 63235       # Arrow Right Key 
  KAUYPLUS  = 63232       # Arrow Up Key 
  KADYMINUS = 63233       # Arrow Down Key 
  KSHIFT    = 131072      # Shift Key 
end#if

def initialize()
  @@nudge='1' if not @@nudge
  model=Sketchup.active_model
  ss=model.selection
  @face=ss[0]
  return nil if not ss[0] or ss[1] or @face.class!=Sketchup::Face
  return nil if not @mat=@face.material or not @mat.texture
  @msg='Empujar Textura: U/X=Flechas Izquierda/Derecha, V/Y=Flechas Arriba/Abajo, +Mayúsculas=10x'
end

def activate
  Sketchup::set_status_text('TTextura Empujar: Introduce Longitud de Incremento')
  @dialoged=false
  return nil if not dt=self.dialog()
  d=dt.tr(',', '.')
  @@nudge=dt
  @shift=false
  begin
    @d=d.to_l
  rescue
    @d=d.tr('.', ',').to_l
    rescue
      return nil
  end
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==KSHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==KSHIFT
      @shift=true  
    else
     case key 
      when KALXMINUS
        if @shift
          self.process(-@d*10, 0)
        else
          self.process(-@d, 0)
        end
        self.reset()
      when KARXPLUS
        if @shift
          self.process(@d*10, 0)
        else
          self.process(@d, 0)
        end
        self.reset()
      when KAUYPLUS
        if @shift
          self.process(0, @d*10)
        else
          self.process(0, @d)
        end
        self.reset()
      when KADYMINUS
        if @shift
          self.process(0, -@d*10)
        else
          self.process(0, -@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(u=nil, v=nil)
  face=@face
  mat=@mat
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not tex=mat.texture
  return nil if not u or not v
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  tx=Geom::Transformation.translation(vx)
  ty=Geom::Transformation.translation(vy)
  tr=tx * ty
  ###
  tpts=[]
  (0..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  d=@@nudge
  results=UI.inputbox(["Incremento [Longitud]:               "], [d], "Empujar Textura")
  return nil if not results
  return results[0]
end

end#class

#==========================================================================

class Scale

@@uscale=nil
@@vscale=nil

def initialize(u=nil,v=nil)
  @@uscale='0.5' if not @@uscale
  @@vscale='0.5' if not @@vscale
  model=Sketchup.active_model
  ss=model.selection
  face=ss[0]
  return nil if not ss[0] or ss[1] or face.class!=Sketchup::Face
  return nil if not mat=face.material or not mat.texture
  if not u or not v
    return nil if not uv=self.dialog()
    if uv[0]==0 or uv[1]==0
      UI.messagebox("¡El Factor de Escala no puede ser CERO!")
      return nil if not uv=self.dialog()
      return nil if uv[0]==0 or uv[1]==0
    end
    ut=uv[0]
    u=ut.tr(',', '.')
    vt=uv[1]
    v=vt.tr(',', '.')
    @@uscale=ut
    @@vscale=vt
    u=u.to_f
    v=v.to_f
    return nil if not u or not v or (u==1 and v==1)
    self.process(face, u, v)
  else
    self.process(face, u, v)
  end#if
end

def dialog()
  u=@@uscale
  v=@@vscale
  results=UI.inputbox(["U: ", "V: "], [u, v], "Escalar Textura")
  return nil if not results
  return results
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, u=1.0, v=1.0)
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not tex=mat.texture
  return nil if u==1.0 and v==1.0
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  ###
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    case i
      when 1
        pt=pts[0].offset(vx)
      when 2
        pt=pts[0].offset(vx)
        pt.offset!(vy)
      when 3
        pt=pts[0].offset(vy)
    end
    tpts << pt
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

end#class

#==========================================================================
class Tweak
  
  @@tweak=nil

if RUBY_PLATFORM=="i386-mswin32" ### PC
  KALXMINUS = 37          # Arrow Left Key 
  KARXPLUS  = 39          # Arrow Right Key 
  KAUYPLUS  = 38          # Arrow Up Key 
  KADYMINUS = 40          # Arrow Down Key 
  KSHIFT    = 16          # Shift Key 
else### MAC
  KALXMINUS = 63234       # Arrow Left Key 
  KARXPLUS  = 63235       # Arrow Right Key 
  KAUYPLUS  = 63232       # Arrow Up Key 
  KADYMINUS = 63233       # Arrow Down Key 
  KSHIFT    = 131072      # Shift Key 
end#if

def initialize()
  @@tweak='0.5' if not @@tweak
  model=Sketchup.active_model
  ss=model.selection
  @face=ss[0]
  return nil if not ss[0] or ss[1] or @face.class!=Sketchup::Face
  return nil if not @mat=@face.material or not @mat.texture
  @msg='Adaptar Textura: Escala U/X=Flechas Izquierda/Derecha +/-, V/Y=Flechas Arriba/Abajo +/-, +Mayúsculas=10x'
end

def activate
  Sketchup::set_status_text('Adaptar Textura: Introduce Factor de Escala')
  @dialoged=false
  return nil if not sft=self.dialog()
  sf=sft.tr(',', '.').to_f
  if sf==0
    UI.messagebox("¡El Factor de Escala no puede ser CERO!")
    return nil if not sft=self.dialog()
    sf=sft.tr(',', '.').to_f
    return nil if sf==0
  end#if
  @@tweak=sft
  @d=sf
  @shift=false
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==KSHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==KSHIFT
      @shift=true  
    else
     case key 
      when KALXMINUS
        if @shift
          self.process(1/-@d*10, 1)
        else
          self.process(1/-@d, 1)
        end
        self.reset()
      when KARXPLUS
        if @shift
          self.process(@d*10, 1)
        else
          self.process(@d, 1)
        end
        self.reset()
      when KAUYPLUS
        if @shift
          self.process(1, @d*10)
        else
          self.process(1, @d)
        end
        self.reset()
      when KADYMINUS
        if @shift
          self.process(1, 1/-@d*10)
        else
          self.process(1, 1/-@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(u=nil, v=nil)
  face=@face
  mat=@mat
  return nil if not face or face.class!=Sketchup::Face
  return nil if not mat=face.material
  return nil if not tex=mat.texture
  return nil if not u or not v
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  ###
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    case i
      when 1
        pt=pts[0].offset(vx)
      when 2
        pt=pts[0].offset(vx)
        pt.offset!(vy)
      when 3
        pt=pts[0].offset(vy)
    end
    tpts << pt
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  d=@@tweak
  results=UI.inputbox(["Factor de Escala:             "], [d], "Adaptar Textura")
  return nil if not results
  return results[0]
end

end#class
#==========================================================================

# menu --------------------------------------------------------------------
if not file_loaded?(File.basename(__FILE__))
    menu=UI.menu("Plugins").add_submenu("Herramientas de Textura...")
    imgdir=File.join(File.dirname(__FILE__),"TIGtools")
    imgpng1=File.join(imgdir,"TextureRotate.png")
    imgpng1a=File.join(imgdir,"TextureAdjust.png")
    imgpng2=File.join(imgdir,"TextureShunt.png")
    imgpng3=File.join(imgdir,"TextureNudge.png")
    imgpng4=File.join(imgdir,"TextureScale.png")
    imgpng5=File.join(imgdir,"TextureTweak.png")
    ###
    cmd1=UI::Command.new("Rotar Textura"){TextureTools::Rotate.new()}
    cmd1a=UI::Command.new("Ajustar Textura"){Sketchup.active_model.select_tool(TextureTools::Adjust.new())}
    cmd2=UI::Command.new("Desviar Textura"){TextureTools::Shunt.new()}
    cmd3=UI::Command.new("Empujar Textura"){Sketchup.active_model.select_tool(TextureTools::Nudge.new())}
    cmd4=UI::Command.new("Escalar Textura"){TextureTools::Scale.new()}
    cmd5=UI::Command.new("Adaptar Textura"){Sketchup.active_model.select_tool(TextureTools::Tweak.new())}
    if File.exist?(imgpng1) or File.exist?(imgpng1a) or File.exist?(imgpng2) or File.exist?(imgpng3) or File.exist?(imgpng4) or File.exist?(imgpng5)
	  new_toolbar=UI::Toolbar.new("Herramientas de Textura")
      new_toolbar.restore if new_toolbar.get_last_state==TB_VISIBLE
    end#if
    if File.exist?(imgpng1)
	  cmd1.small_icon=imgpng1
	  cmd1.large_icon=imgpng1
      new_toolbar.add_item(cmd1)
	end#if
    if File.exist?(imgpng1a)
	  cmd1a.small_icon=imgpng1a
	  cmd1a.large_icon=imgpng1a
      new_toolbar.add_item(cmd1a)
	end#if
    if File.exist?(imgpng2)
	  cmd2.small_icon=imgpng2
	  cmd2.large_icon=imgpng2
      new_toolbar.add_item(cmd2)
	end#if
    if File.exist?(imgpng3)
	  cmd3.small_icon=imgpng3
	  cmd3.large_icon=imgpng3
      new_toolbar.add_item(cmd3)
	end#if
    if File.exist?(imgpng4)
	  cmd4.small_icon=imgpng4
	  cmd4.large_icon=imgpng4
      new_toolbar.add_item(cmd4)
	end#if
    if File.exist?(imgpng5)
	  cmd5.small_icon=imgpng5
	  cmd5.large_icon=imgpng5
      new_toolbar.add_item(cmd5)
	end#if
	cmd1.tooltip="Rotar Textura"
	cmd1.status_bar_text="Rotar Textura: Rotar la Textura de la Cara Seleccionada por Ángulo..."
	cmd1.menu_text="Rotar Textura"
	cmd1a.tooltip="Ajustar Textura"
	cmd1a.status_bar_text="Ajustar Textura: Ajustar [Rotar] la Textura de la Cara Seleccionada con las Teclas-Flechas..."
	cmd1a.menu_text="Ajustar Textura"
	cmd2.tooltip="Desviar Textura"
	cmd2.status_bar_text="Desviar Textura: Desvia la Textura de la Cara Seleccionada por distancias UV..."
	cmd2.menu_text="Desviar Textura"
	cmd3.tooltip="Empujar Textura"
	cmd3.status_bar_text="Empujar Textura: Empuja la Textura de la Cara Seleccionada con las Teclas-Flechas..."
	cmd3.menu_text="Empujar Textura"
    cmd4.tooltip="Escalar Textura"
	cmd4.status_bar_text="Escalar Textura: Escala la Textura de la Cara Seleccionada en UV..."
	cmd4.menu_text="Escalar Textura"
	cmd5.tooltip="Adaptar Textura"
	cmd5.status_bar_text="Adaptar Textura: Adapta [Escala] la Textura de la Cara Seleccionada con las Teclas-Flechas..."
	cmd5.menu_text="Adaptar Textura"
	menu.add_item(cmd1)
	menu.add_item(cmd1a)
	menu.add_item(cmd2)
	menu.add_item(cmd3)
	menu.add_item(cmd4)
	menu.add_item(cmd5)
    ###
end
file_loaded(File.basename(__FILE__))

end#module